<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/17/2011 *
 * ===================                          Last change: 09/17/2011 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ajax.php                                         *
 * -------------------------------------------------------------------- *
 * Short description : AJAX backend script                              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : AJAX-Abfragescript                               *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// XDEBUG call
//* DEBUG: */ xdebug_start_trace();

// Load security system
require('inc/libs/security_functions.php');

// Init start time
$GLOBALS['__start_time'] = microtime(TRUE);

/*
 * Set output to "AJAX mode", proper module and prevent HTML headers/footers
 * being sent.
 */
$GLOBALS['__output_mode'] = -2;
$GLOBALS['__module']      = 'ajax';
$GLOBALS['__header_sent'] = 2;
$GLOBALS['__footer_sent'] = 2;

// Load config file
require('inc/config-global.php');

// Load special AJAX library
loadIncludeOnce('inc/ajax-functions.php');

// Init AJAX request (including HTTP status code)
initAjax();

// Load header here
loadIncludeOnce('inc/header.php');

// Process only POST requests and that at least 'level' is set
if ((getHttpRequestMethod() == 'POST') && (isPostRequestElementSet('level'))) {
	// Okay, that is valid, now check that the requested level right is valid
	if (isAjaxRequestLevelValid()) {
		// Process the request
		processAjaxRequest();

		// Is there an error? ('200 OK' is fine)
		if ((getHttpStatus() != '200 OK') && (getHttpStatus() != '404 NOT FOUND')) {
			// The process was handled but didn't work
			reportBug(__FUNCTION__, __LINE__, 'AJAX request is valid but does not do anything.');
		} // END - if
	} else {
		// Not allowed
		setHttpStatus('403 Forbidden');
	}
} // END - if

// Footer
loadIncludeOnce('inc/footer.php');

// [EOF]
?>
